// st1.pov (c) J"urgen Hochwald
// jh@cfjh.de
// Pov-File f"ur PovRay 3.5
// 7.2.1997 Initial Version
// 9.7.2003 Modifications, changes and optimisations for Pov 3.5

global_settings { max_trace_level 50 }

#include "shapes.inc"
#include "colors.inc"
#include "textures.inc"

#declare L_Pos = <-60, 0, -50>;
#declare L_Rot = <0, 60, 0>;
#declare L_scale = <1, 1, 2>;
#declare BlauGruen = color red 0.5 green 0.9 blue 0.9;

camera {
   location <10.0,  30.0,  -100.0>
   up  <0.0,  1.0,  0.0>
   right <1.33333, 0.0, 0.0>
   look_at <0, 0, 0>
 }

#declare Saule =
union {
  intersection {
    object {
      Cylinder_Y
    }
    plane { <0, 1, 0> 0  }
  }
  sphere { <0, 0, 0> 1  }
  
  scale <3, 3, 3>
}

#declare Pimmel =
union {
  object { Saule translate < -6,  14, 0>   }
  object { Saule translate <-12,  15, 0>   }
  object { Saule translate <-18,  20, 0>   }
  object { Saule translate <-24,  21, 0>   }
  object { Saule translate <-30,  26, 0>   }
  object { Saule translate <-36,  26, 0>   }
  object { Saule translate <-42,  32, 0>   }
  object { Saule translate <-48,  33, 0>   }
  object { Saule translate <-54,  34, 0>   }
  object { Saule translate <-60,  41, 0>   }

  object { Saule translate <-15,  11,  -4>   }
  object { Saule translate <-21,  15,  -4>   }
  object { Saule translate <-27,  21,  -4>   }
  object { Saule translate <-33,  20,  -4>   }
  object { Saule translate <-39,  25,  -4>   }
  object { Saule translate <-45,  25,  -4>   }
  object { Saule translate <-51,  34,  -4>   }
  object { Saule translate <-57,  36,  -4>   }
  object { Saule translate <-63,  39,  -4>   }

  object { Saule translate <-24,  13, -8 >   }
  object { Saule translate <-30,  13, -8 >   }
  object { Saule translate <-36,  17, -8 >   }
  object { Saule translate <-42,  21, -8 >   }
  object { Saule translate <-48,  26, -8 >   }
  object { Saule translate <-54,  30, -8 >   }
  object { Saule translate <-60,  30, -8 >   }

  object { Saule translate <-33,  10, -12>   }
  object { Saule translate <-39,  14, -12>   }
  object { Saule translate <-45,  22, -12>   }
  object { Saule translate <-51,  25, -12>   }
  object { Saule translate <-57,  28, -12>   }
  object { Saule translate <-63,  30, -12>   }

  object { Saule translate <-42,  11, -16>   }
  object { Saule translate <-48,  17, -16>   }
  object { Saule translate <-54,  21, -16>   }
  object { Saule translate <-60,  22, -16>   }

  object { Saule translate <-51,  13, -20>   }
  object { Saule translate <-57,  19, -20>   }
  
  texture {
    pigment { color red 0.8 green 0.8 blue 0.8 }
    normal { bumps 0.4 }
    finish {
      phong 0.7
      phong_size 30
    }
  }
}

#declare KettenTorus = union {
  #local i=0;
  #while (i<16)
    torus { 3.5, 1.25
      texture {
        pigment { color Yellow }
        finish {
          ambient 0.3
          diffuse 0.7
          reflection 0.5
          brilliance 5.0
        }
      }
      rotate <90,0,0>
      #if (odd(i)=0)
        rotate <0,45,0>
      #else
        rotate <0,-45,0>
      #end
      translate <14,0,0>
      rotate <0,0,i*22.5>
    }

    #local i=i+1;
  #end

  scale <0.5, 0.5, 0.5>
  //rotate <-55, 20, 0>
  //rotate <0, 0, 0>
  translate <-10, 12, -65>
}

#declare Eck6 =
intersection {
  plane { <1, 0, 0> 3                     }
  plane { <1, 0, 0> 3 rotate <0,  60, 0>  }
  plane { <1, 0, 0> 3 rotate <0, 120, 0>  }
  plane { <1, 0, 0> 3 rotate <0, 180, 0>  }
  plane { <1, 0, 0> 3 rotate <0, 240, 0>  }
  plane { <1, 0, 0> 3 rotate <0, 300, 0>  }
  plane { <0, 1, 0> 0  }

  texture {
    pigment { color BlauGruen }
  }
}

#declare Sechsecke = union {
  object { Eck6 translate < 6,  13,   0> rotate <   0,   0,   3>   }
  object { Eck6 translate <12,  16,   0> rotate <   9,   0,   6>   }
  object { Eck6 translate <18,  19,   0> rotate <  14,   0,  13>   }
  object { Eck6 translate <24,  22,   0> rotate <  -7,   0,  15>   }
  object { Eck6 translate <30,  25,   0> rotate < -10,   0,   8>   }
  object { Eck6 translate <36,  28,   0> rotate <   1,   0,   3>   }
  object { Eck6 translate <42,  31,   0> rotate < -12,   0,  12>   }
  object { Eck6 translate <48,  34,   0> rotate < -12,   0,   3>   }
  object { Eck6 translate <54,  37,   0> rotate <  12,   0,   6>   }
  object { Eck6 translate <60,  40,   0> rotate <  -5,   0,   1>   }

  object { Eck6 translate <15,  13,  -4> rotate <   5,   0,  12>   }
  object { Eck6 translate <21,  16,  -4> rotate <  11,   0,   4>   }
  object { Eck6 translate <27,  19,  -4> rotate <   5,   0,  14>   }
  object { Eck6 translate <33,  22,  -4> rotate <  -9,   0,   6>   }
  object { Eck6 translate <39,  25,  -4> rotate <  -7,   0,  13>   }
  object { Eck6 translate <45,  28,  -4> rotate <   1,   0,  14>   }
  object { Eck6 translate <51,  31,  -4> rotate <  -9,   0,   1>   }
  object { Eck6 translate <57,  34,  -4> rotate < -12,   0,   3>   }
  object { Eck6 translate <63,  37,  -4> rotate <   2,   0,  13>   }

  object { Eck6 translate <24,  13, -8 > rotate <  -3,   0,   8>   }
  object { Eck6 translate <30,  16, -8 > rotate <  -9,   0,   3>   }
  object { Eck6 translate <36,  19, -8 > rotate <  -1,   0,   9>   }
  object { Eck6 translate <42,  22, -8 > rotate <  -6,   0,   5>   }
  object { Eck6 translate <48,  25, -8 > rotate <  -7,   0,   9>   }
  object { Eck6 translate <54,  28, -8 > rotate <  -4,   0,   4>   }
  object { Eck6 translate <60,  31, -8 > rotate <  -1,   0,   7>   }

  object { Eck6 translate <33,  13, -12> rotate <   5,   0,  13>   }
  object { Eck6 translate <39,  16, -12> rotate <   8,   0,   4>   }
  object { Eck6 translate <45,  19, -12> rotate <   5,   0,  13>   }
  object { Eck6 translate <51,  22, -12> rotate <   4,   0,   8>   }
  object { Eck6 translate <57,  25, -12> rotate <   9,   0,   6>   }
  object { Eck6 translate <63,  28, -12> rotate <   8,   0,  12>   }

  object { Eck6 translate <42,  13, -16> rotate <  -7,   0,   8>   }
  object { Eck6 translate <48,  16, -16> rotate <   5,   0,  14>   }
  object { Eck6 translate <54,  19, -16> rotate <  12,   0,   9>   }
  object { Eck6 translate <60,  22, -16> rotate <  15,   0,   9>   }

  object { Eck6 translate <51,  13, -20> rotate <   7,   0,   7>   }
  object { Eck6 translate <57,  16, -20> rotate <   5,   0,   1>   }
}

#declare Kugel1 = sphere { <0,0,0> 1.8
  texture {
    pigment { color red 1.0 green 0.0 blue 0.0 }
    finish {
      // reflection 0.1
      // brilliance 3.0
      specular 0.25
      roughness 0.1
    }
  }
}

#declare Kugel2 = sphere { <0,0,0> 1.2
  texture {
    pigment { color red 0.3 green 0.3 blue 1.0 }
    finish {
      specular 0.5
      roughness 0.01
    }
  }
}

#declare KugelWuerfel = union {
  #local MAX=5;
  #local a=0;
  #while (a<MAX)
    #local b=0;
    #while (b<MAX)
      #local c=0;
      #while (c<MAX)

        object {
          #if (odd(a+b+c)=0)
	    Kugel1
	  #else
	    Kugel2
	  #end
	  translate <3*a,3*b,3*c>
        }

	#local c=c+1;
      #end
      #local b=b+1;
    #end
    #local a=a+1;
  #end
  rotate <-25,10,0>
  translate <-40, 32, 20>
 }

#declare Kugel3=object {
  sphere { <0, 0, 0> 2  }
  texture {
    pigment { color White }
    finish {
      ambient 0.0
      diffuse 0.3
      reflection 1.0
      brilliance 3.0
      specular 1.0
      roughness 0.01
    }
  }
}

#declare Torus1 = object {
  torus {3.5, 0.75}
  texture {
    pigment { color red 0.6 green 0.6 blue 1.0 filter 1.0 }
    finish {
      ambient 0.1
      diffuse 0.1
      reflection 0.1
      //refraction 0.9
      phong 0.3
      phong_size 60
    }
  }
  interior {
    ior 1.5
    fade_power 0.9
    fade_distance 10
  }
  rotate <30, 0, 0>
}

#declare TorusKugeln = union {
  object { Kugel3 translate < 0,  0,  0>  }
  object { Kugel3 translate < 0,  4,  0>  }
  object { Kugel3 translate < 0,  8,  0>  }
  object { Kugel3 translate < 0, 12,  0>  }
  object { Kugel3 translate < 0, 16,  0>  }
  object { Kugel3 translate < 0, 20,  0>  }
  object { Torus1 rotate < 0,   0,  0> translate < 0,  4,  0>  }
  object { Torus1 rotate < 0, 120,  0> translate < 0, 10,  0>  }
  object { Torus1 rotate < 0, 240,  0> translate < 0, 16,  0>  }
  translate <20, 2, -50>
 }

#declare KugelReihe = object {
  union{
    #local i=0;
    #local Base  = <-40, 85, 210>;
    #local Shift = <  3, -2.5, -10>;
    #while (i<26)
      #local i=i+1;
      sphere{Base+i*Shift, 2}
    #end
  }
  pigment { color rgbf <0.9,0.9,1,1> }
  finish {
    reflection 0.3
    specular 0.5
    roughness 0.01
  }
  interior {
    ior 1.5
    fade_power 0.5
    fade_distance 10
  }
  translate <0, 2, 0>
  no_shadow
}

#declare Berge =
object {
   height_field {
      gif "fract001.gif"
   }
   translate <-0.5,-0.5,-0.5>
   scale <200,-60,80>
   scale 3.1
   rotate <-35,0,15>
   translate <-50,0,300>
   texture {
      pigment { color rgb <0.7,0.7,0.7> }
   }
}

/* Boden */
#declare Boden = object {
   plane { <0.0, 1.0, 0.0> 0  }
   texture {
      pigment {
        bozo
        colour_map {
          [0.0 0.3   colour red 0.80 green 0.60 blue 0.0
                     colour red 0.80 green 0.60 blue 0.0]
          [0.3 1.001 colour red 0.80 green 0.60 blue 0.0
                     colour red 0.47 green 0.39 blue 0.0]
        }
        quick_color Yellow
      }
      finish {
        ambient 0.2
        diffuse 0.8
      }
      rotate <-90, 0, 0>
      scale < 5.0 5.0 5.0 >
    }
 }

/* Himmel */
#declare Himmel = object {
  sphere { <0, -9500, 0> 10000  inverse }
  texture {
    pigment {
      bozo
      colour_map { /* Sky colors */
          [0.0 0.5   colour red 0.25 green 0.25 blue 0.5
                     colour red 0.25 green 0.25 blue 0.5]
          [0.5 0.6   colour red 0.25 green 0.25 blue 0.5
                     colour red 0.7 green 0.7 blue 0.7]
          [0.6 1.001 colour red 0.7 green 0.7 blue 0.7
                     colour red 0.3 green 0.3 blue 0.3]
      }
      turbulence 0.3
    }
    finish {
      ambient 0.6
      diffuse 0.7
    }
    scale <350.0, 250.0, 250.0>
  }
}

object {
  light_source { <50.0,  200.0,  -200.0>
    color White
  }
}


object { Pimmel }
object { KettenTorus }
object { Sechsecke }
object { KugelWuerfel }
object { TorusKugeln }
object { KugelReihe }
object { Berge }
object { Boden }
object { Himmel }
